package ru.amse.cat.evlarchick.textstructure;

import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class SimpleAnalyser implements IAnalyser {
    private Pattern myPattern;

    public SimpleAnalyser(Pattern pattern) {
        myPattern = pattern;
    }

    public void analyse(ITextStructure textStructure) {
        Matcher m = myPattern.matcher(textStructure.getOriginalText());

        int i = 0;

        ISegment current = Segment.createSegment(textStructure);

        while (m.find(i)) {
            try {
                i = m.end();
                if (current.getEnd() == m.start()) {
                    // boolean!!!
                    current.setEnd(i);
                } else {
                    current = new Segment(m.start(), i, textStructure);
                    textStructure.addDeadZone(current);
                }
            } catch (SegmentIsTooBigException e) {
                i = m.start() + 1;
            }
        }
    }
}
